import { AnimationEngine } from "../AnimationEngine";
import { timingFunctionDefinition } from "../timingFunction";
export declare function animate(options?: AnimateOptions): <C extends Function>(WrappedComponent: C) => C;
export declare type AnimateOptions = AnimationOptions & AnimationConfig;
export interface AnimationOptions {
    properties?: PropertiesDefinition;
    animationEngine?: AnimationEngine;
}
export interface AnimationConfig {
    duration?: number;
    timingFunction?: timingFunctionDefinition;
}
export declare type PropertiesDefinition = null | string[] | {
    [id: string]: AnimationConfig | true;
};
export declare type BoolMap = {
    [id: string]: boolean;
};
