"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bezier = require("bezier-easing");
function timingFunction(definition) {
    if (typeof definition === "string") {
        return getByName(definition);
    }
    else if (Array.isArray(definition) && definition.length >= 4) {
        return getBezierByCoefficients(definition);
    }
    return definition;
}
exports.timingFunction = timingFunction;
var easings = {
    "ease": [0.25, 0.1, 0.25, 1.0],
    "linear": [0.00, 0.0, 1.00, 1.0],
    "ease-in": [0.42, 0.0, 1.00, 1.0],
    "ease-out": [0.00, 0.0, 0.58, 1.0],
    "ease-in-out": [0.42, 0.0, 0.58, 1.0]
};
function getByName(name) {
    return getBezierByCoefficients(easings[name]);
}
function getBezierByCoefficients(coefficients) {
    return bezier(coefficients[0], coefficients[1], coefficients[2], coefficients[3]);
}
